import re
from pathlib import Path
from typing import Match, List, Any


def detect_mul(data: str) -> list[Match]:
    return re.findall(r"mul\((\d{1,3}),(\d{1,3})\)", data)


def compute_multiplication(data: str) -> int:
    result = 0
    for match in detect_mul(data):
        left = int(match[0])
        right = int(match[1])
        result += left * right
    return result


def main(input_file: Path) -> int:
    input = "".join([line for line in input_file.open()])
    return compute_multiplication(input)


if __name__ == "__main__":
    file = Path(__file__).parent / "input-data"
    print(main(file))
