from pathlib import Path

import numpy as np


def is_vertical_upwards(data, i, j) -> bool:
    if i < 3:
        return False
    try:
        if data[i - 1, j] == "M":
            if data[i - 2, j] == "A":
                if data[i - 3, j] == "S":
                    return True
    except IndexError:
        return False
    return False


def is_vertical_downwards(data, i, j) -> bool:
    try:
        if data[i + 1, j] == "M":
            if data[i + 2, j] == "A":
                if data[i + 3, j] == "S":
                    return True
    except IndexError:
        return False
    return False


def is_horizontal_backwards(data, i, j) -> bool:
    if j < 3:
        return False
    try:
        if data[i, j - 1] == "M":
            if data[i, j - 2] == "A":
                if data[i, j - 3] == "S":
                    return True
    except IndexError:
        return False
    return False


def is_horizontal_forwards(data, i, j) -> bool:
    try:
        if data[i, j + 1] == "M":
            if data[i, j + 2] == "A":
                if data[i, j + 3] == "S":
                    return True
    except IndexError:
        return False
    return False


def is_diagonal_forwards_downwards(data, i, j):
    try:
        if data[i + 1, j + 1] == "M":
            if data[i + 2, j + 2] == "A":
                if data[i + 3, j + 3] == "S":
                    return True
    except IndexError:
        return False
    return False


def is_diagonal_forwards_upwards(data, i, j):
    if i < 3:
        return False
    try:
        if data[i - 1, j + 1] == "M":
            if data[i - 2, j + 2] == "A":
                if data[i - 3, j + 3] == "S":
                    return True
    except IndexError:
        return False
    return False


def is_diagonal_backwards_upwards(data, i, j):
    if i < 3 or j < 3:
        return False
    try:
        if data[i - 1, j - 1] == "M":
            if data[i - 2, j - 2] == "A":
                if data[i - 3, j - 3] == "S":
                    return True
    except IndexError:
        return False
    return False


def is_diagonal_backwards_downwards(data, i, j):
    if j < 3:
        return False
    try:
        if data[i + 1, j - 1] == "M":
            if data[i + 2, j - 2] == "A":
                if data[i + 3, j - 3] == "S":
                    return True
    except IndexError:
        return False
    return False


def find_xmas(data: np.array):
    score = 0
    for i in range(data.shape[0]):
        for j in range(data.shape[1]):
            if data[i, j] == "X":
                if is_horizontal_forwards(data, i, j):
                    score += 1
                if is_horizontal_backwards(data, i, j):
                    score += 1
                if is_vertical_downwards(data, i, j):
                    score += 1
                if is_vertical_upwards(data, i, j):
                    score += 1
                if is_diagonal_forwards_downwards(data, i, j):
                    score += 1
                if is_diagonal_forwards_upwards(data, i, j):
                    score += 1
                if is_diagonal_backwards_downwards(data, i, j):
                    score += 1
                if is_diagonal_backwards_upwards(data, i, j):
                    score += 1

    return score


def main(file: Path) -> int:
    data_str = file.read_text()
    x_axis_size = data_str.find("\n")
    y_axis_size = data_str.count("\n") + 1
    data = np.full((x_axis_size, y_axis_size), "")
    i, j = 0, 0
    for character in data_str:
        if character != "\n":
            data[i, j] = character
            j += 1
        else:
            i += 1
            j = 0
    return find_xmas(data)


if __name__ == "__main__":
    input_file = Path(__file__).parent / "input-data"
    print(main(input_file))
